unit LTR27_FORM;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, ltr27api,  ltrapitypes,  ltrapi;

type
  TForm1 = class(TForm)
    Button1: TButton;
    SpinEdit1: TSpinEdit;
    Memo1: TMemo;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Edit6: TEdit;
    Edit7: TEdit;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Edit8: TEdit;
    Edit9: TEdit;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Edit10: TEdit;
    Edit11: TEdit;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Edit12: TEdit;
    Edit13: TEdit;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Edit14: TEdit;
    Edit15: TEdit;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Edit16: TEdit;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
label exit;
var ltr27: TLTR27;
    LTR:TLTR;
    CompanyName:PChar;
    DeviceName:PChar;
    Serial, SerialM: PChar;
    Name, NameM: PChar;
    ClockRate: double;
    Firmware, Calibration, Revision: double;
    Comment: PChar;
    ErrorString: PChar;
    i, j: Cardinal;
    buf: array[0..15] of Cardinal;
    dest_buf: array[0..15] of double;
    size: integer;
    data_size: Cardinal;
    err:Integer;
begin
 //  
err:=LTR27_Init(@ltr27);

if(err=LTR_OK) then
   memo1.Lines.Add('Module initialization is successfully')
else
 begin
  //     
  ErrorString:=LTR27_GetErrorString(err);
   //     , ..   
  CharToOem(ErrorString,ErrorString);
  //   
  memo1.Lines.Add(ErrorString);
  goto exit;
 end;
 LTR_Init(@LTR);
err:= LTR_Open(@LTR);
if(err<>LTR_OK) then
   memo1.Lines.Add('Crate Open Error!');
//   
err:=LTR27_Open(@ltr27, LTR.saddr, LTR.sport, @LTR.csn, SpinEdit1.Value);

if(err=LTR_OK) then
   memo1.Lines.Add('Module has opened successfully')
else
 begin
  ErrorString:=LTR27_GetErrorString(err);
  CharToOem(ErrorString,ErrorString);
  memo1.Lines.Add(ErrorString);

  goto exit;
 end;

 //  
err:=LTR27_GetConfig(@ltr27);

if(err=LTR_OK) then
   memo1.Lines.Add('Module has configured successfully')
else
 begin
  ErrorString:=LTR27_GetErrorString(err);
  CharToOem(ErrorString,ErrorString);
  memo1.Lines.Add(ErrorString);

  goto exit;
 end;


 //    
err:=LTR27_GetDescription(@ltr27, LTR27_ALL_DESCRIPTION);
{if(err=LTR_OK) then
  for i:=1 to LTR27_MEZZANINE_NUMBER  do
    if (ltr27.Mezzanine[i].Name <> 'EMPTY') then
      err:=LTR27_GetDescription(@ltr27, LTR27_MEZZANINE1_DESCRIPTION shl i); }
if(err=LTR_OK) then
   memo1.Lines.Add('Module has description successfully')
else
 begin
  ErrorString:=LTR27_GetErrorString(err);
  CharToOem(ErrorString,ErrorString);
  memo1.Lines.Add(ErrorString);

  goto exit;
 end;
//    . 
memo1.Lines.Add('Module description: ');

CompanyName:=@ltr27.ModuleInfo.Module.CompanyName;
memo1.Lines.Add('CompanyName: '+CompanyName);


DeviceName:=@ltr27.ModuleInfo.Module.DeviceName;
memo1.Lines.Add('DeviceName: '+DeviceName);


Serial:=@ltr27.ModuleInfo.Module.Serialnumber;
memo1.Lines.Add('Serial number: '+Serial);
memo1.Lines.Add('');
if (ltr27.ModuleInfo.Cpu.Active<>0) then
 begin
  memo1.Lines.Add('CPU description: ');

  Name:=@ltr27.ModuleInfo.Cpu.Name;
  memo1.Lines.Add('Name: '+Name);
  ClockRate:=ltr27.ModuleInfo.Cpu.ClockRate;
  memo1.Lines.Add('ClockRate: '+floattostr(ClockRate));
  Firmware:=ltr27.ModuleInfo.Cpu.FirmwareVersion;
  memo1.Lines.Add('FirmwareVersion: '+floattostr(Firmware));
  Comment:=@ltr27.ModuleInfo.Cpu.Comment;
  memo1.Lines.Add('Comment: '+Comment);
 end
else
  memo1.Lines.Add('CPU description not present ');

for i:=0 to LTR27_MEZZANINE_NUMBER-1  do
   if (ltr27.ModuleInfo.Mezzanine[i].Active<>0) then
    begin
      memo1.Lines.Add('');
      memo1.Lines.Add('Mezzanine'+ inttostr(i)+' description: ');

      NameM:=@ltr27.ModuleInfo.Mezzanine[i].Name;
      memo1.Lines.Add('Name: '+NameM);
      SerialM:=@ltr27.ModuleInfo.Mezzanine[i].Serialnumber;
      memo1.Lines.Add('Serial number: '+SerialM);
      Revision:=ltr27.ModuleInfo.Mezzanine[i].Revision;
      memo1.Lines.Add('Revision: '+floattostr(Revision));
      for j:=0 to 3 do
        begin
          Calibration:=ltr27.ModuleInfo.Mezzanine[i].Calibration[j];
          memo1.Lines.Add('Calibration'+inttostr(j) +' : '+floattostr(Calibration));

        end;
    end;

//    100 
ltr27.FrequencyDivisor:= 9;
   
//   
for i:=0 to LTR27_MEZZANINE_NUMBER-1  do
  for j:=0 to 3 do
    ltr27.Mezzanine[i].CalibrCoeff[j]:=ltr27.ModuleInfo.Mezzanine[i].Calibration[j];

//      
err:= LTR27_SetConfig(@ltr27);

if(err=LTR_OK) then
   memo1.Lines.Add('Module has seted successfully')
else
 begin
  ErrorString:=LTR27_GetErrorString(err);
  CharToOem(ErrorString,ErrorString);
  memo1.Lines.Add(ErrorString);

  goto exit;
 end;

//    
err:= LTR27_ADCStart(@ltr27);

if(err>=LTR_OK) then begin
   //   
    size:= LTR27_Recv(@ltr27, @buf[0], nil, 16, 1000);
    memo1.Lines.Add('Size= '+inttostr(size));
    if (size>=0) then
      begin
        data_size:= size;
        err:= LTR27_ProcessData(@ltr27,@buf[0],@dest_buf[0],@data_size,true,true);
        if(err=LTR_OK) then
          begin
            //  
              i:=1;
                   Edit1.Text:=floattostr(dest_buf[0]);
                   Edit2.Text:=floattostr(dest_buf[1]);
                   Edit3.Text:=floattostr(dest_buf[2]);
                   Edit4.Text:=floattostr(dest_buf[3]);
                   Edit5.Text:=floattostr(dest_buf[4]);
                   Edit6.Text:=floattostr(dest_buf[5]);
                   Edit7.Text:=floattostr(dest_buf[6]);
                   Edit8.Text:=floattostr(dest_buf[7]);
                   Edit9.Text:=floattostr(dest_buf[8]);
                  Edit10.Text:=floattostr(dest_buf[9]);
                  Edit11.Text:=floattostr(dest_buf[10]);
                  Edit12.Text:=floattostr(dest_buf[11]);
                  Edit13.Text:=floattostr(dest_buf[12]);
                  Edit14.Text:=floattostr(dest_buf[13]);
                  Edit15.Text:=floattostr(dest_buf[14]);
                  Edit16.Text:=floattostr(dest_buf[15]);
          end;
      end;
   end
else
 begin
  ErrorString:=LTR27_GetErrorString(err);
  CharToOem(ErrorString,ErrorString);
  memo1.Lines.Add(ErrorString);
   goto exit;
 end;

err:= LTR27_ADCStop(@ltr27);

if(err=LTR_OK) then
   memo1.Lines.Add('Module has stoped successfully')
else
 begin
  ErrorString:=LTR27_GetErrorString(err);
  CharToOem(ErrorString,ErrorString);
  memo1.Lines.Add(ErrorString);
    goto exit;
 end;

 //    

exit:


memo1.Lines.Add('Closing module');
LTR27_Close(@ltr27);
end;

end.
